module API 
 (  
      getSpwdName
    , putSpwd
    , getNames
 )
where

import Spwd
import qualified GenericAPI as GenericAPI (getSpwdName, putSpwd, getNames)

import SecLib.Trustworthy 
import SecLib.LatticeLH

passwd :: File L 
passwd = mkFile "./passwd"

shadow :: File H
shadow = mkFile "./shadow"

getSpwdName :: Name -> SecIO s (Maybe Spwd)
getSpwdName = GenericAPI.getSpwdName passwd shadow 

putSpwd :: Spwd -> SecIO H ()
putSpwd = GenericAPI.putSpwd shadow 

getNames :: SecIO s [Name]
getNames = GenericAPI.getNames passwd

-- Login 

check :: Sec H (String, Cypher) -> SecIO s (Sec L Bool) 
check = hatch (\(input, c) -> input == c) 


