module GenericAPI 
 (  
      getSpwdName
    , putSpwd
    , getNames
 )
where


import Spwd
import SecLib.Untrustworthy
import SecLib.LatticeLH 


getSpwdName :: File L -> File H -> Name -> SecIO s (Maybe Spwd)
getSpwdName passwd shadow user = 
      do  pw     <- parse_passwd passwd    
          sec_sh <-  parse_shadow shadow   -- sec_sh :: Sec H
          case lookup user pw of
               Nothing   -> return Nothing
               Just id   -> return $ 
                             Just $ Spwd { uid = id, cypher = do sh <- sec_sh 
                                                                 case lookup id sh of
                                                                      Nothing -> error "Violation integrity shadow file!"
                                                                      Just c  -> return c
                                         } 

putSpwd :: File H -> Spwd -> SecIO H () 
putSpwd shadow spwd = do sec_shs  <- parse_shadow shadow  -- sec_sh :: Sec H 
                         sh <- value sec_shs  
                         c  <- value $ cypher spwd
                         let id = uid spwd
                             updated = [ (id', c')  | (id', c') <- sh, id /= id' ] ++ [(id,c)]
                         writeFileSecIO shadow (show updated)  


getNames :: File L -> SecIO s [Name]
getNames passwd = do pwd <- parse_passwd passwd 
                     return $ [ name | (name,_) <- pwd ]