{-# LANGUAGE FlexibleContexts,RankNTypes #-}
module Login 

where

import Spwd
import qualified ULogin as ULogin (login) 

import SecLib.Trustworthy 
import SecLib.LatticeLH



-- Defines a escape hatch 
check :: Sec H (String, Cypher) -> SecIO s (Sec L Bool)
check = hatch (\(input, key) -> input == key)

check3 :: IO (Sec H (String, Cypher) -> SecIO s (Sec L Bool))
check3 = ntimes 3 check

-- Sets the screen to be a public channel
screen :: Screen L
screen = mkScreen ()

safe_login :: ( Screen L 
                -> (Sec H (String, Cypher) -> SecIO s (Sec L Bool))
                -> SecIO L () 
              ) 
              -> IO () 

safe_login expected_login = do escape_hatch <- check3 
                               run $ expected_login screen escape_hatch  
                               return ()

login = safe_login ULogin.login 




      
