module Spwd 
 (  
      UID 
    , Cypher 
    , Name 
    , Spwd (..)
    , parse_passwd
    , parse_shadow
 )
where

import SecLib.Untrustworthy
import SecLib.LatticeLH

type UID    = Int 
type Cypher = String
type Name   = String

data Spwd = Spwd { uid :: UID, cypher :: Sec H Cypher } 

parse_passwd :: File L -> SecIO s [(Name, UID)]
parse_passwd passwd = do s <- readFileSecIO passwd
                         let s'' = public s
                         (s'' == s'') `seq` return  (read s'' :: [(Name, UID)])

parse_shadow :: File H -> SecIO s (Sec H [(UID, Cypher)])
parse_shadow shadow  = do s <- readFileSecIO shadow 
                          return $ (\s -> (s == s) `seq` (read s :: [(UID, Cypher)])) `fmap` s


 
 